/*[L[[*/
/*MPLAB IDE v8.88*/
/*@\ǉ*/
/*irtxdispv6̈ڍs*/
/*V42 //폜yуj[C*/

#include<htc.h>

__CONFIG(FOSC_HS & WDTE_OFF & PWRTE_ON & BOREN_OFF & LVP_OFF &DEBUG_OFF & CP_OFF);
#define _XTAL_FREQ	20000000

#define	LCD_DDR		TRISD	//
#define	LCD_port	PORTD   //
#define	LCD_RS		RD4     //
#define	LCD_E		RD5     //
#define LCD_K		RD6		//LEDXCb`	

#define SW0 		RB0		//XCb`0
#define SW1			RB1		//XCb`P
#define KEY_MON		RB2
#define MON			RB3		//j^[	PFIt@OFI		
#define TR_KEY		RB4		//I[vRN^o
#define IR_LED		RB5		//ԊOled

#define M1 			RC0		//`l1
#define M2 			RC1		//`l2
#define M3 			RC2		//`l3
#define M4 			RC3		//`l4
#define M5 			RC4		//`l5
#define M6 			RC5		//`l6

static int i=0;
static int j=0;
static int k=0;

static long counter;

static unsigned char jconv=0;
static unsigned char mon_sw=0;


/* LCD 4rbg ------*/
void LCD_out4( unsigned char data )
{
	unsigned char	tmp1, tmp2;
	LCD_E = 1;					/* E MZbg */
	tmp1 = LCD_port &0xf0;		/* RS Mi[ */
	tmp2 = (data >>4) &0x0f;	/*  4bit ݒ */
	LCD_port = tmp1 | tmp2;		/* RS+datao */
	__delay_us(400);
	LCD_E = 0;
	__delay_us(400);	
	LCD_E = 1;					/* E MZbg */
	tmp1 = LCD_port &0xf0;		/* RS Mi[ */
	tmp2 = data &0x0f;			/*  4bit ݒ */
	LCD_port = tmp1 | tmp2;		/* RS+datao */
  	__delay_us(400);	
	LCD_E = 0;
  	__delay_us(400);	

}

/* LCD 8rbg*/
static	void _LCD_out8( unsigned char data )
{
	__delay_us(400);	
    LCD_RS = 0;						/* @\ݒ*/
	LCD_E = 1;						/* E MZbg */
	LCD_port = data;				/* ް */
 	__delay_us(400);	
	LCD_E = 0;
 	__delay_us(400);	
}

/* LCD */
void LCD_init()
{
	LCD_DDR = 0xb00;				/* Port D o͐ݒ */
	__delay_ms(15);
	_LCD_out8( 0x23 );				/* @\ݒ 1 */
	__delay_ms(10);
	_LCD_out8( 0x23 );				/* @\ݒ 2 */
	__delay_ms(2);
	_LCD_out8( 0x23 );				/* @\ݒ 3 */
	__delay_ms(1);	
	_LCD_out8( 0x22 );				/* @\ݒ */
	__delay_ms(1);	
	LCD_RS = 0;					/* @\ݒ */
	LCD_out4( 0x28 );				/* @\ݒ */
  	__delay_ms(1);		
	LCD_RS = 0;
	LCD_out4( 0x0e );				/* fBXvCEIAJ[\EI */
	__delay_ms(1);	
	LCD_RS = 0;
	LCD_out4( 0x06 );				/* Ӱ */
	__delay_ms(1);	
	LCD_RS = 0;
	LCD_out4( 0x01 );				/* ިڲر */
 	__delay_ms(2);
}

/* LCD Ps\*/
void LCD_disp( unsigned char *str, int line )
{
	unsigned char	*ad;
	int	i;

	LCD_RS = 0;						/* @\ݒ */
	if( line==1 ) LCD_out4( 0x80 );	/*1s  */
	else LCD_out4( 0xc0 );			/* 2s  */
	ad = str;
	for( i=0; i<16; i++ ){			/* o͕ */
		if( *ad == 0 ) return;		/* IȂreturn*/
		LCD_RS = 1;			        /* ްӰސݒ */
		__delay_us(40);
		LCD_out4( *ad );
		__delay_us(60);
		LCD_RS = 0;
		ad++;
	}
}

/* LCD\ʒuw(s, ) */
void LCD_locate( int line, int col )
{
	unsigned char	dat;

	if( line ==1 ) dat = (unsigned char)col + 0x80;
	if( line >=2 ) dat = (unsigned char)col + 0xc0;
	LCD_RS = 0;						/* set function */
	LCD_out4( dat );
}

/* LCD1\*/
void LCD_char( unsigned char dat )
{
	LCD_RS = 1;						/* set data mode */
	__delay_us(40);	
	LCD_out4( dat );
	__delay_us(60);	
	LCD_RS = 0;
}

/* LCD֕f[^HEXQ\*/
void LCD_hex( unsigned char dat )
{
	unsigned char	hex;

	hex = ( (dat>>4) &0x0f) + 0x30;
	if( hex >0x39 ) hex += 0x07;
	LCD_char( hex );
	hex = ( dat &0x0f) + 0x30;
	if( hex >0x39 ) hex += 0x07;
	LCD_char( hex );
}


/*LCD֐lf[^\*/
void LCD_dataout( unsigned long data )

{ 
    unsigned char temp;
    char strtemp[ 10 ];            
    int i, k;
    i=0;
    do {
        temp = data % 10;
        strtemp[i++] = temp + '0';
    } while (( data /= 10 ) != 0); 
    i--; 
    for( k=i; k>=0; k-- ) {
        LCD_char( strtemp[k]);
    }
}

static void interrupt isr(void)
{
	T0IF=0;
	INTF=0;
	counter++;		
		if (counter>20000){
			counter=0;
			TMR0=0;
			LCD_K=0;
			SLEEP();
			LCD_K=1;
	}
}

/********ԊOLEDfOfo*****************************/
void outl(){
	IR_LED=0;
	__delay_us(390);
}

/********ԊOLEDfPfo***************************/
void outh(){
	i=0;
	while(i<15){
		IR_LED=1;
		__delay_us(10);
		IR_LED=0;
		__delay_us(10);
		i++;
	}
}

/*************Xy[XM*****************/
void key_space(int data)
{
	j=data;
	for (i=0;i<j;i++){
		__delay_ms(5);
	}
}

/********}[NM*****************/
void key_mark(int data)
{
	unsigned char buf;
	if(mon_sw==1){
		MON=0;
	}
	else{
		MON=1;
	}
	TR_KEY=1;
	for(k=0;k<data;k++){
		buf=0xf2;
		outh();			//1oCg޲f[^[ X^[grbg		
		for(j=0;j<8;j++){
   			if ((buf & 0x01)==1){
				outh();
			}
			else{
				outl();
			}
			buf=buf>>1;
		}
		outh();   //Xgbvrbg
		__delay_us(380);
	}
	TR_KEY=0;				
	MON=1;
//MON=0;
}


/*******r[v***********/
void beep(int number)
{
	int counter;
	int w;
	counter=number;
	for (w=0;w<counter;w++){
		MON=0;
		__delay_ms(30);
		MON=1;
		__delay_ms(30);
	}
}

/********timer************/
void msec_timer(int msec)
{
	int counter;
	for (counter=0;counter<msec;counter++){
		__delay_ms(1);
	}
}

/**************̓R[hϊ*******************/
unsigned char decode_e(unsigned int data)
{
	unsigned char disp_data;

		disp_data=0x5f;

		if(data==0x0d){			
			disp_data=0x41;		//A
		}
		if(data==0x57){
			disp_data=0x42;		//B
		}
		if(data==0x77){
			disp_data=0x43;		//C
		}
		if(data==0x17){
			disp_data=0x44;		//D
		}		
		if(data==0x01){
			disp_data=0x45;		//E
		}
		if(data==0x75){
			disp_data=0x46;		//F
		}
		if(data==0x1f){
			disp_data=0x47;		//G
		}
		if(data==0x055){
			disp_data=0x48;		//H
		}
		if(data==0x05){
			disp_data=0x49;		//I
		}
		if(data==0xfd){
			disp_data=0x4a;		//J
		}
		if(data==0x37){
			disp_data=0x4b;		//K
		}
		if(data==0x5d){
			disp_data=0x4c;		//L
		}
		if(data==0x0f){
			disp_data=0x4d;		//M
		}
		if(data==0x07){
			disp_data=0x4e;		//N
		}
		if(data==0x03f){
			disp_data=0x4f;		//O
		}
		if(data==0x07d){
			disp_data=0x50;		//P
		}
		if(data==0xdf){
			disp_data=0x51;		//Q
		}
		if(data==0x1d){
			disp_data=0x52;		//R
		}
		if(data==0x15){
			disp_data=0x53;		//S
		}
		if(data==0x03){
			disp_data=0x54;		//T
		}
		if(data==0x35){
			disp_data=0x55;		//U
		}
		if(data==0xd5){
			disp_data=0x56;		//V
		}
		if(data==0x3d){
			disp_data=0x57;		//W
		}
		if(data==0xd7){
			disp_data=0x58;		//X
		}
		if(data==0xf7){
			disp_data=0x59;		//Y
		}
		if(data==0x5f){
			disp_data=0x5a;		//Z
		}
		if(data==0x01d1){
			disp_data=0x2e;		//.
		}
		if(data==0x035f){
			disp_data=0x2c;		//,
		}
		if(data==0x057f){
			disp_data=0x3b;		//;
		}
		if(data==0x07fd){
			disp_data=0x27;		//'
		}
		if(data==0x0d57){
			disp_data=0x2d;		//-
		}
		if(data==0x01f7){
			disp_data=0x28;		//(
		}
		if(data==0x0df7){
			disp_data=0x29;		//)
		}
		if(data==0x01d7){
			disp_data=0x2f;		///
		}
/*
		if(data==0x01dd){
			disp_data=0x2b;		//+
		}
*/
		if(data==0x075d){
			disp_data=0x22;		//"
		}
		if(data==0x077d){
			disp_data=0x40;		//@
		}

	return disp_data;
}


/**************̓R[hϊEa*******************/
unsigned char decode_j(unsigned int data)
{
	unsigned char disp_data;
		disp_data=0x5f;
		if(data==0x03df){			
			disp_data=0xb1;		//A
		}
		if(data==0x000d){
			disp_data=0xb2;		//C
		}
		if(data==0x0035){
			disp_data=0xb3;		//E
		}
		if(data==0x03f7){
			disp_data=0xb4;		//G
		}		
		if(data==0x015d){
			disp_data=0xb5;		//I
		}
		if(data==0x005d){
			disp_data=0xb6;		//J
		}
		if(data==0x0177){
			disp_data=0xb7;		//L
		}
		if(data==0x00d5){
			disp_data=0xb8;		//N
		}
		if(data==0x00f7){
			disp_data=0xb9;		//P
		}
		if(data==0x00ff){
			disp_data=0xba;		//R
		}
		if(data==0x0377){
			disp_data=0xbb;		//T
		}
		if(data==0x01df){
			disp_data=0xbc;		//V
		}
		if(data==0x037f){
			disp_data=0xbd;		//X
		}
		if(data==0x01fd){
			disp_data=0xbe;		//Z
		}
		if(data==0x007f){
			disp_data=0xbf;		// \ 
		}
		if(data==0x0007){
			disp_data=0xc0;		//^
		}
		if(data==0x0075){
			disp_data=0xc1;		//`
		}
		if(data==0x007d){
			disp_data=0xc2;		//c
		}
		if(data==0x03dd){
			disp_data=0xc3;		//e
		}
		if(data==0x0175){
			disp_data=0xc4;		//g
		}
		if(data==0x001d){
			disp_data=0xc5;		//i
		}
		if(data==0x0077){
			disp_data=0xc6;		//
		}
		if(data==0x0055){
			disp_data=0xc7;		//k
		}
		if(data==0x00df){
			disp_data=0xc8;		//
		}
		if(data==0x00f5){
			disp_data=0xc9;		//m
		}
		if(data==0x0057){
			disp_data=0xca;		//n
		}
		if(data==0x035f){			
			disp_data=0xcb;		//q
		}
		if(data==0x005f){
			disp_data=0xcc;		//t
		}
		if(data==0x0001){
			disp_data=0xcd;		//w
		}
		if(data==0x0017){
			disp_data=0xce;		//z
		}		
		if(data==0x00d7){
			disp_data=0xcf;		//}
		}
		if(data==0x0375){
			disp_data=0xd0;		//~
		}
		if(data==0x0003){
			disp_data=0xd1;		//
		}
		if(data==0x00357){
			disp_data=0xd2;		//
		}
		if(data==0x01d7){
			disp_data=0xd3;		//
		}
		if(data==0x003d){
			disp_data=0xd4;		//
		}
		if(data==0x03d7){
			disp_data=0xd5;		//
		}
		if(data==0x000f){
			disp_data=0xd6;		//
		}
		if(data==0x0015){
			disp_data=0xd7;		//
		}
		if(data==0x001f){
			disp_data=0xd8;		//
		}
		if(data==0x01f7){
			disp_data=0xd9;		//
		}
		if(data==0x003f){
			disp_data=0xda;		//
		}
		if(data==0x00dd){
			disp_data=0xdb;		//
		}
		if(data==0x035d){
			disp_data=0x5f;		//
		}
		if(data==0x017d){
			disp_data=0x5f;		//
		}
		if(data==0x00fd){
			disp_data=0xa6;		//
		}
		if(data==0x0037){
			disp_data=0xdc;		//
		}
		if(data==0x01dd){
			disp_data=0xdd;		//
		}
		if(data==0x0005){
			disp_data=0xde;		//J
		}
		if(data==0x01f5){
			disp_data=0xdf;		//K
		}
		if(data==0x037d){
			disp_data=0xb0;		//[
		}
		if(data==0x0d00){
			disp_data=0xa4;		//A
		}
		if(data==0x0df7){
			disp_data=0x28;		//(
		}
		if(data==0x075d){
			disp_data=0x29;		//)
		}

		return disp_data;
}

/**************̓R[hϊEL*******************/
unsigned char decode(unsigned int data)
{
	unsigned char disp_data;
	unsigned int c_data;

		c_data=data;
		disp_data=0x5f;

		if(data==0x02|data==0x00){	//" "
			disp_data=0xfe;
		}
		if(data==0x03ff){		//0
			disp_data=0x30;
		}
		if(data==0x03fd){		//1
			disp_data=0x31;
		}
		if(data==0x03f5){		//2
			disp_data=0x32;
		}		
		if(data==0x03d5){		//3
			disp_data=0x33;
		}
		if(data==0x0355){		//4
			disp_data=0x34;
		}
		if(data==0x0155){
			disp_data=0x35;		//5
		}
		if(data==0x0157){
			disp_data=0x36;		//6
		}
		if(data==0x015f){
			disp_data=0x37;		//7
		}
		if(data==0x017f){
			disp_data=0x38;		//8
		}
		if(data==0x01ff){
			disp_data=0x39;		//9
		}
		if(data==0x05f5){
			disp_data=0x3f;		//?
		}

		if(disp_data==0x5f){
			if(jconv==1){			
				disp_data=decode_j(c_data);
			}
			else{
				disp_data=decode_e(c_data);
			}
		}
	return disp_data;
}

/*******CHECK M6************/
unsigned int M6_check(void)
{
	if(M6==0){
		i=0;
		j=0;
		while(M6==0){
			__delay_ms(1);
			i++;			
			if(i>500){
				j=1;
			}
		}
		msec_timer(50);
	}
	return j;
}

main(){
	unsigned char buf=0x00;
	unsigned int mark;
	unsigned int dot;
	int s;
	int t;
	int u;
	int mch;
	int key_st;

	unsigned int m_buf[20]={0x0000};
	unsigned int chr_buf=0x0000;
	unsigned int code_buf=0x0000;
	unsigned int check_buf;
	char m_address=0x00;
	unsigned char eeprom_buf=0x00;
	unsigned int chr_buf1;
	unsigned int chr_buf2;
	unsigned char func_m=0;
	unsigned char m_rept=0;			//M3:JԂXCb`
	unsigned char key_speed=1;		//M4:L[CCOx
	unsigned char key_p=0;			//M5:	phړ_ؑ
	unsigned char key_const=9;
	unsigned char disp_chr;
	int disp_degit=0;
	unsigned char disp_buf[16];
	unsigned char disp_clr[]="                ";
	unsigned char space_disp=0;
	unsigned char key=0;

	TRISA=0b11111111;
	TRISB=0b00100011;
	TRISC=0b00111111;
	PORTD=0b01000000;

	nRBPU=0;

	MON=1;
	KEY_MON=0;
	IR_LED=0;

	T0CS=0;
	PSA=0;
	PS0=1;
	PS1=1;
	PS2=1;

	LCD_init();
	__delay_ms(5);
	LCD_K=1;
	LCD_locate(1,0);
	LCD_disp("  MEMORY KEYER  ",1);

	msec_timer(1000);

	T0IF=0;					//荞݃tbONA
	INTF=0;
	TMR0=0;					//^C}[0NA		
	GIE=1;	

/*****@\ݒ菉****/
BIGIN:

	jconv=eeprom_read(241);
	if(jconv>0){
		jconv=1;
	}
	mon_sw=eeprom_read(242);
	if(mon_sw>0){
		mon_sw=1;
	}
	m_rept=eeprom_read(243);
	if(m_rept>0){
		m_rept=1;
	}
	key_speed=eeprom_read(244);
	if(key_speed>9){
		key_speed=1;
	}
	key_p=eeprom_read(245);
		if(key_p>0){
		key_p=1;
	}

	LCD_out4( 0x01 );				/* ިڲر */
	__delay_ms(2);
	LCD_out4( 0x0c );				//j[\@J[\
	LCD_disp(" M1 M2 M3 M4 M5 ",1);

	if(jconv ==0){
		LCD_locate(2,1);
		LCD_char(0x45);
	}
	else{
		LCD_locate(2,1);
		LCD_char(0x4a);
	}

	if(mon_sw ==1){
		LCD_locate(2,4);
		LCD_char(0x4d);
	}
	else{
		LCD_locate(2,4);
		LCD_char(0x2d);
	}

	if(m_rept ==1){
		LCD_locate(2,7);
		LCD_char(0x52);		
	}
	else{
		LCD_locate(2,7);
		LCD_char(0x4e);
		LCD_locate(2,8);
		LCD_char(0x52);
	}

	LCD_locate(2,10);
	LCD_dataout(key_speed);

	if(key_p==1){
		LCD_locate(2,13);
		LCD_char(0x4B);
		LCD_locate(2,14);
		LCD_char(0x41);
	}
	else{
		LCD_locate(2,13);
		LCD_char(0x4B);
		LCD_locate(2,14);
		LCD_char(0x42);
	}

	while(M6==0);

	while(1){	
		if(M1==0){
			func_m=1;
			if(jconv==1){
				jconv=0;
				LCD_locate(2,1);
				LCD_char(0x45);
			}
			else{
				jconv=1;
				LCD_locate(2,1);
				LCD_char(0x4a);
			}
			while(M1==0);
			msec_timer(10);
		}
		if(M2==0){
			func_m=1;
				if(mon_sw==0){
				mon_sw=1;
				LCD_locate(2,4);
				LCD_char(0x4d);
			}
			else{
				mon_sw=0;
				LCD_locate(2,4);
				LCD_char(0x2d);
			}
			while(M2==0);
			msec_timer(10);
		}
		if(M3==0){
			func_m=1;
				if(m_rept==0){
				m_rept=1;
				LCD_locate(2,7);
				LCD_char(0x52);
				LCD_locate(2,8);
				LCD_char(0xfe);			
			}
			else{
				m_rept=0;																									
				LCD_locate(2,7);
				LCD_char(0x4e);
				LCD_locate(2,8);
				LCD_char(0x52);	
			}
			while(M3==0);
			msec_timer(10);
		}
		if(M4==0){
			func_m=1;
			key_speed=key_speed+1;
			if(key_speed>9){
				key_speed=1;
			}
			LCD_locate(2,10);
			LCD_dataout(key_speed);
			while(M4==0);
			msec_timer(10);
		}
		if(M5==0){
			func_m=1;
				if(key_p==0){
				key_p=1;
				LCD_locate(2,13);
				LCD_char(0x4B);
				LCD_locate(2,14);
				LCD_char(0x41);		

			}
			else{
				key_p=0;																						
				LCD_locate(2,13);
				LCD_char(0x4B);
				LCD_locate(2,14);
				LCD_char(0x42);
			}
			while(M5==0);
			msec_timer(10);
		}
		if(M6==0){
			break;
		}
	}

	LCD_out4( 0x01 );				/* ިڲر */	
	__delay_ms(1);
	disp_degit=0;
	LCD_out4( 0x0e );				//J[\I
	if(func_m==1){	
		eeprom_write(241,jconv);
		eeprom_write(242,mon_sw);
		eeprom_write(243,m_rept);
		eeprom_write(244,key_speed);
		eeprom_write(245,key_p);
		func_m=0;
	}

	while(1){
TOP:
		dot=key_speed*2+key_const;
		mark=dot*3;			//_L[CCOݒ

		T0IE=1;				//TIMER0荞݋
		INTE=1;				//INT荞݋

		if(M6_check()==1){
			goto BIGIN;
		}

/***************`lݒ********************************/
		if (M1==0 || M2==0 || M3==0 || M4==0 || M5 ==0){
			T0IE=0;
			INTE=0;
			TMR0=0;
			counter=0;
			LCD_out4( 0x01 );				/* ިڲر */	
			__delay_ms(2);			

			if (M1==0){
				LCD_disp("M1:",1);
				m_address=0x00;	//0
			}
			if (M2==0){
				LCD_disp("M2:",1);
				m_address=0x28;	//40
			}
			if (M3==0){
				LCD_disp("M3:",1);
				m_address=0x50;	//80
			}
			if (M4==0){
				LCD_disp("M4:",1);
				m_address=0x78;	//120
			}
			if (M5==0){
				LCD_disp("M5:",1);
				m_address=0xa0;	//160	
			}			

			for(i=0;i>16;i++){
				disp_buf[i]=0x00;
			}
			LCD_locate(1,3);
			disp_degit=3;

			t=0;
			while(M1==0 || M2==0 || M3==0 || M4==0 || M5 ==0){
				__delay_ms(1);
				t++;
				if(t>500){
					beep(1);
				}
			}
			msec_timer(10);			
/***************[h**************************/
			if(t<=500){
				t=0;					
				while(t<20){								//EEPROMǂݏo																
					chr_buf1=eeprom_read(m_address+(t*2));
					__delay_ms(10);
					chr_buf2=eeprom_read(m_address+(t*2+1));
					__delay_ms(10);
					chr_buf2=chr_buf2<<8;
					m_buf[t]=chr_buf1|chr_buf2;
					t++;
				}

				for(t=0;t<20;t++){
					if(m_buf[t]==0x00){
						break;
					}
					else{
						chr_buf=m_buf[t];
					}
					disp_chr=decode(chr_buf);		//ROMǂݏoM\
					LCD_char(disp_chr);				//
					disp_degit++;
					if (disp_degit>15){				//		
						LCD_locate(2,0);			//
						disp_degit=0;
					}
				}
				msec_timer(1000);					//
REPT:
				LCD_K=1;							//LCDƖLED
				LCD_out4( 0x01 );					//ިڲر
				__delay_ms(2);
				for(i=0;i>16;i++){
					disp_buf[i]=0x00;
				}
				disp_degit=0;

				t=0;
				while(t<20){						//20o	
					chr_buf=m_buf[t];



					if(chr_buf==0x0000){
						if(m_rept==1){
							goto REPT;
						}
						msec_timer(200);
						LCD_out4( 0x01 );				/* ިڲر */
						__delay_ms(2);
						disp_degit=0;
						goto TOP;
					}


					disp_chr=decode(chr_buf);		//M\
					LCD_char(disp_chr);				//
					disp_degit++;
					if (disp_degit>15){				//
						LCD_locate(2,0);			//
						disp_degit=0;
					}

					s=0;	
					while(s<16){
						if(SW0==0 || SW1==0){
							LCD_out4( 0x01 );				/* ިڲر */
							disp_degit=0;
							while(SW0==0 || SW1==0);
							msec_timer(50);
							goto TOP;
						}
						code_buf=0x0000;
						code_buf=chr_buf & 0x0003;
						if(code_buf==0x0000){			//o͊
							break;
						}
						if(code_buf==0x0001){			//Z_
							key_mark(dot);
						}
						if(code_buf==0x0003){			//_
							key_mark(mark);
						}
						if(code_buf==0x0002){			//ԋʃhbgXy[X(1+2)܂7hbgXy[X
							u=0;
							for(u=0;u<4;u++){
								key_space(dot);
							}
						}

						key_space(dot);
						chr_buf=chr_buf>>2;
						s++;
					}	

					for(u=0;u<2;u++){						//؂2Xy[Xo͂
						key_space(dot);
					}
					t++;
				}

				if(m_rept==1){
					goto REPT;
				}
				else{
					msec_timer(200);
					LCD_out4( 0x01 );				/* ިڲر */
					__delay_ms(2);
					disp_degit=0;
					goto TOP;
				}

			}

/***********Cg*****************************/

			else{
				s=0;
				while(s<20){			//EPROM݃obt@
					m_buf[s]=0x0000;
					s++;
				}
				key_st=1;
				t=0;
B1:
				while(t<20){
					if (M1==0 || M2==0 || M3==0 || M4==0 || M5 ==0){						
						if(t==0){
							if (M1==0 || M2==0 || M3==0 || M4==0 || M5 ==0); //KeyJ҂						msec_timer(500);
							goto TOP;
						}
						beep(5);				//݋@\Ir[v5
						
						if (M1==0 || M2==0 || M3==0 || M4==0 || M5 ==0); //KeyJ҂
						msec_timer(700);
						goto MWRITE;				//ݏ
					}
B2:
					chr_buf=0;
					s=0;
					while(s<8){
						if (SW0==0 || SW1==0){
							key_st=0;
B3:	
							MON=0;
							if(key_p==0){
								if (SW0==0){
									key_space(mark);			//Ir LED
									code_buf=0xc000;			//_
								}
								else{
									key_space(dot);				//Ir LED
									code_buf=0x4000;			//Z_
								}
							}
							else{
								if (SW1==0){
									key_space(mark);			//Ir LED
									code_buf=0xc000;			//_
								}
								else{
									key_space(dot);				//Ir LED
									code_buf=0x4000;			//Z_
								}
							}
							MON=1;
							key_space(dot);

							if(s>0){
								chr_buf=chr_buf>>2;
							}
							chr_buf=chr_buf|code_buf;							
							s++;
						}
						else{
//								goto B4;			//͖΂P͊ֈڍs
break;
						}
					}

if(chr_buf==0x0505 || s>7){
					beep(8);		//1I[o[t[x
	t--;
	disp_degit--;
	if(disp_degit<3 && t<3){
		t++;
		disp_degit++;
	}
	else{
		if(t<13){
			LCD_locate(1,t+3);
			if(t==12){
				disp_degit=15;
			}
		}
		else{
			if(t==16){
				disp_degit=0;
			}
			LCD_locate(2,t-13);
		}
	}
	goto B2;
}

//B4:
					if(key_st==1 || s==0){
						goto B1;				//͊JnOA͒O͖̕΁A͑҂ֈڍs
					}

					u=0;						//0.5Sԓ͖΂P͊ֈڍs
					while(SW0==1 && SW1==1){
						if(u<500){
							__delay_ms(1);
							u++;
						}
						else{
							goto B5;
						}
					}
					goto B3;
B5:
					chr_buf=chr_buf>>(16-s*2);	//͒l擪փVtg
					__delay_ms(30);	
					beep(2);					//1͊mFr[v2
					m_buf[t]=chr_buf;   		//1obt@֏

					disp_chr=decode(m_buf[t]);	//ROM݈ꕶ\
					disp_degit++;
					LCD_char(disp_chr);				//
					if(disp_degit>15){
						LCD_locate(2,0);			//
						disp_degit=0;				//
					}

					s=0;
					t++;
					if(t>20){
						break;
					}

					u=0;						//ꕶAPSԓ͖΂P[h͊ֈڍs
					while(SW0==1 && SW1==1){
						if(u<1500){
							__delay_ms(1);
							u++;
						}
						else{
							goto B6;
						}
					}
					goto B2;
B6:
					m_buf[t]=0x0002;		//[h؂蕄				
					beep(4);				//1[h͊mFr[vQ

					disp_chr=decode(m_buf[t]);	//ROM݈ꕶ\
					LCD_char(disp_chr);				//
					disp_degit++;					//
					if(disp_degit>15){
						LCD_locate(2,0);			//
						disp_degit=0;				//
					}
					t++;
				}
				beep(10);					//QOI[o[t[xr[vPOA

MWRITE:
				while(t<40){						//EEPROM
					eeprom_write(m_address+(t),0x0000);
					t++;
				}

				t=20;
				s=0;									
				while (s<20){						//EEPROM݁
					eeprom_write(m_address+(s*2),m_buf[s]);
					__delay_ms(1);
					m_buf[s]=m_buf[s]>>8;
					eeprom_write(m_address+(s*2+1),m_buf[s]);
					__delay_ms(1);
					s++;
				}
			}

			LCD_out4( 0x01 );				/* ިڲر */
			__delay_ms(2);
			for(i=0;i>16;i++){
				disp_buf[i]=0x00;
			}
		}


/***********L[ph*****************************/

		if(SW0==0 || SW1==0 ){
			T0IE=0;
			INTE=0;
			TMR0=0;
			counter=0;

			chr_buf=0;
			s=0;
			while(s<8){
				if (SW0==0 || SW1==0){
					if(key_p==0){
						if (SW0==0){
							key_mark(mark);
							code_buf=0xc000;			//_
						}
						else{
							key_mark(dot);				
							code_buf=0x4000;			//Z_
						}
					}
					else{
						if (SW0==1){
							key_mark(mark);
							code_buf=0xc000;			//_
						}
						else{
							key_mark(dot);				
							code_buf=0x4000;			//Z_
						}
					}

					key_space(dot);

					if(s>0){
						chr_buf=chr_buf>>2;
					}
					chr_buf=chr_buf|code_buf;							
					s++;
				}
				else{
					break;
				}
			}


			if(s>=1){
				chr_buf=chr_buf>>(16-s*2);		//͒l擪փVtg
				disp_chr=decode(chr_buf);		//P\
				LCD_char(disp_chr);				//
				disp_buf[disp_degit]=disp_chr;	//
				disp_degit++;
				if (disp_degit>15){				//
					LCD_disp(disp_buf,1);		//
					LCD_disp(disp_clr,2);		//
					LCD_locate(2,0);			//
					disp_degit=0;				//
				}

				s=0;
				key_space(dot);
				space_disp=0;
				key=1;
			}
		}

		if(key==1){
			if(space_disp==5*dot){
				chr_buf=0x0002;
				disp_chr=decode(chr_buf);		//P\
				LCD_char(disp_chr);				//
				disp_buf[disp_degit]=disp_chr;	//
				disp_degit++;
				if (disp_degit>15){				//
					LCD_disp(disp_buf,1);		//
					LCD_disp(disp_clr,2);		//
					LCD_locate(2,0);			//
					disp_degit=0;				//
				}
				space_disp=0;
				key=0;
			}
			else{
				msec_timer(4);
				space_disp++;
			}
		}


	}				//End while
}					//End main
